<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfLookupItemWithCode ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfLookupItemWithCode
 * @subpackage Arrays
 */
class ArrayOfLookupItemWithCode extends AbstractStructArrayBase
{
    /**
     * The LookupItemWithCode
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\LookupItemWithCode[]
     */
    public $LookupItemWithCode;
    /**
     * Constructor method for ArrayOfLookupItemWithCode
     * @uses ArrayOfLookupItemWithCode::setLookupItemWithCode()
     * @param \StructType\LookupItemWithCode[] $lookupItemWithCode
     */
    public function __construct(array $lookupItemWithCode = array())
    {
        $this
            ->setLookupItemWithCode($lookupItemWithCode);
    }
    /**
     * Get LookupItemWithCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\LookupItemWithCode[]|null
     */
    public function getLookupItemWithCode()
    {
        return isset($this->LookupItemWithCode) ? $this->LookupItemWithCode : null;
    }
    /**
     * Set LookupItemWithCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\LookupItemWithCode[] $lookupItemWithCode
     * @return \ArrayType\ArrayOfLookupItemWithCode
     */
    public function setLookupItemWithCode(array $lookupItemWithCode = array())
    {
        foreach ($lookupItemWithCode as $arrayOfLookupItemWithCodeLookupItemWithCodeItem) {
            // validation for constraint: itemType
            if (!$arrayOfLookupItemWithCodeLookupItemWithCodeItem instanceof \StructType\LookupItemWithCode) {
                throw new \InvalidArgumentException(sprintf('The LookupItemWithCode property can only contain items of \StructType\LookupItemWithCode, "%s" given', is_object($arrayOfLookupItemWithCodeLookupItemWithCodeItem) ? get_class($arrayOfLookupItemWithCodeLookupItemWithCodeItem) : gettype($arrayOfLookupItemWithCodeLookupItemWithCodeItem)), __LINE__);
            }
        }
        if (is_null($lookupItemWithCode) || (is_array($lookupItemWithCode) && empty($lookupItemWithCode))) {
            unset($this->LookupItemWithCode);
        } else {
            $this->LookupItemWithCode = $lookupItemWithCode;
        }
        return $this;
    }
    /**
     * Add item to LookupItemWithCode value
     * @throws \InvalidArgumentException
     * @param \StructType\LookupItemWithCode $item
     * @return \ArrayType\ArrayOfLookupItemWithCode
     */
    public function addToLookupItemWithCode(\StructType\LookupItemWithCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\LookupItemWithCode) {
            throw new \InvalidArgumentException(sprintf('The LookupItemWithCode property can only contain items of \StructType\LookupItemWithCode, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->LookupItemWithCode[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\LookupItemWithCode|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\LookupItemWithCode|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\LookupItemWithCode|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\LookupItemWithCode|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\LookupItemWithCode|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LookupItemWithCode
     */
    public function getAttributeName()
    {
        return 'LookupItemWithCode';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfLookupItemWithCode
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
