<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Authenticate' => '\\StructType\\Authenticate',
            'AuthenticateResponse' => '\\StructType\\AuthenticateResponse',
            'WebUser' => '\\StructType\\WebUser',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'ArrayOfAttribute' => '\\ArrayType\\ArrayOfAttribute',
            'Attribute' => '\\StructType\\Attribute',
            'StratogSecureSoapHeader' => '\\StructType\\StratogSecureSoapHeader',
            'GetAttributeLookupValuesWithCodes' => '\\StructType\\GetAttributeLookupValuesWithCodes',
            'GetAttributeLookupValuesWithCodesResponse' => '\\StructType\\GetAttributeLookupValuesWithCodesResponse',
            'ArrayOfLookupItemWithCode' => '\\ArrayType\\ArrayOfLookupItemWithCode',
            'LookupItemWithCode' => '\\StructType\\LookupItemWithCode',
            'ExtensionDataObject' => '\\StructType\\ExtensionDataObject',
            'GetUserByUniqueId' => '\\StructType\\GetUserByUniqueId',
            'GetUserByUniqueIdResponse' => '\\StructType\\GetUserByUniqueIdResponse',
            'GetIndividualRefByAttributeCode' => '\\StructType\\GetIndividualRefByAttributeCode',
            'GetIndividualRefByAttributeCodeResponse' => '\\StructType\\GetIndividualRefByAttributeCodeResponse',
            'GetIndividualRefByAttributeDescription' => '\\StructType\\GetIndividualRefByAttributeDescription',
            'GetIndividualRefByAttributeDescriptionResponse' => '\\StructType\\GetIndividualRefByAttributeDescriptionResponse',
            'GetUserByToken' => '\\StructType\\GetUserByToken',
            'GetUserByTokenResponse' => '\\StructType\\GetUserByTokenResponse',
            'IsUserLoggedIn' => '\\StructType\\IsUserLoggedIn',
            'IsUserLoggedInResponse' => '\\StructType\\IsUserLoggedInResponse',
            'IsValidRequest' => '\\StructType\\IsValidRequest',
            'IsValidRequestResponse' => '\\StructType\\IsValidRequestResponse',
            'GetUserStatus' => '\\StructType\\GetUserStatus',
            'GetUserStatusResponse' => '\\StructType\\GetUserStatusResponse',
            'UserStatus' => '\\StructType\\UserStatus',
            'GetMemberRoles' => '\\StructType\\GetMemberRoles',
            'GetMemberRolesResponse' => '\\StructType\\GetMemberRolesResponse',
            'Terminate' => '\\StructType\\Terminate',
            'TerminateResponse' => '\\StructType\\TerminateResponse',
            'GetAllCountries' => '\\StructType\\GetAllCountries',
            'GetAllCountriesResponse' => '\\StructType\\GetAllCountriesResponse',
            'ArrayOfCountryFile' => '\\ArrayType\\ArrayOfCountryFile',
            'CountryFile' => '\\StructType\\CountryFile',
        );
    }
}
