<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetUserByToken StructType
 * @subpackage Structs
 */
class GetUserByToken extends AbstractStructBase
{
    /**
     * The Token
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Token;
    /**
     * The AttributeType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $AttributeType;
    /**
     * Constructor method for GetUserByToken
     * @uses GetUserByToken::setToken()
     * @uses GetUserByToken::setAttributeType()
     * @param string $token
     * @param string $attributeType
     */
    public function __construct($token = null, $attributeType = null)
    {
        $this
            ->setToken($token)
            ->setAttributeType($attributeType);
    }
    /**
     * Get Token value
     * @return string|null
     */
    public function getToken()
    {
        return $this->Token;
    }
    /**
     * Set Token value
     * @param string $token
     * @return \StructType\GetUserByToken
     */
    public function setToken($token = null)
    {
        // validation for constraint: string
        if (!is_null($token) && !is_string($token)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($token)), __LINE__);
        }
        $this->Token = $token;
        return $this;
    }
    /**
     * Get AttributeType value
     * @return string|null
     */
    public function getAttributeType()
    {
        return $this->AttributeType;
    }
    /**
     * Set AttributeType value
     * @param string $attributeType
     * @return \StructType\GetUserByToken
     */
    public function setAttributeType($attributeType = null)
    {
        // validation for constraint: string
        if (!is_null($attributeType) && !is_string($attributeType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($attributeType)), __LINE__);
        }
        $this->AttributeType = $attributeType;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetUserByToken
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
