<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StratogSecureSoapHeader StructType
 * Meta informations extracted from the WSDL
 * - type: tns:StratogSecureSoapHeader
 * @subpackage Structs
 */
class StratogSecureSoapHeader extends AbstractStructBase
{
    /**
     * The webUserName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $webUserName;
    /**
     * The webPassWord
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $webPassWord;
    /**
     * Constructor method for StratogSecureSoapHeader
     * @uses StratogSecureSoapHeader::setWebUserName()
     * @uses StratogSecureSoapHeader::setWebPassWord()
     * @param string $webUserName
     * @param string $webPassWord
     */
    public function __construct($webUserName = null, $webPassWord = null)
    {
        $this
            ->setWebUserName($webUserName)
            ->setWebPassWord($webPassWord);
    }
    /**
     * Get webUserName value
     * @return string|null
     */
    public function getWebUserName()
    {
        return $this->webUserName;
    }
    /**
     * Set webUserName value
     * @param string $webUserName
     * @return \StructType\StratogSecureSoapHeader
     */
    public function setWebUserName($webUserName = null)
    {
        // validation for constraint: string
        if (!is_null($webUserName) && !is_string($webUserName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($webUserName)), __LINE__);
        }
        $this->webUserName = $webUserName;
        return $this;
    }
    /**
     * Get webPassWord value
     * @return string|null
     */
    public function getWebPassWord()
    {
        return $this->webPassWord;
    }
    /**
     * Set webPassWord value
     * @param string $webPassWord
     * @return \StructType\StratogSecureSoapHeader
     */
    public function setWebPassWord($webPassWord = null)
    {
        // validation for constraint: string
        if (!is_null($webPassWord) && !is_string($webPassWord)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($webPassWord)), __LINE__);
        }
        $this->webPassWord = $webPassWord;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StratogSecureSoapHeader
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
