<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UserStatus StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:UserStatus
 * @subpackage Structs
 */
class UserStatus extends AbstractStructBase
{
    /**
     * The UserLoggedIn
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $UserLoggedIn;
    /**
     * The RequestIdValid
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $RequestIdValid;
    /**
     * Constructor method for UserStatus
     * @uses UserStatus::setUserLoggedIn()
     * @uses UserStatus::setRequestIdValid()
     * @param bool $userLoggedIn
     * @param bool $requestIdValid
     */
    public function __construct($userLoggedIn = null, $requestIdValid = null)
    {
        $this
            ->setUserLoggedIn($userLoggedIn)
            ->setRequestIdValid($requestIdValid);
    }
    /**
     * Get UserLoggedIn value
     * @return bool
     */
    public function getUserLoggedIn()
    {
        return $this->UserLoggedIn;
    }
    /**
     * Set UserLoggedIn value
     * @param bool $userLoggedIn
     * @return \StructType\UserStatus
     */
    public function setUserLoggedIn($userLoggedIn = null)
    {
        // validation for constraint: boolean
        if (!is_null($userLoggedIn) && !is_bool($userLoggedIn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($userLoggedIn)), __LINE__);
        }
        $this->UserLoggedIn = $userLoggedIn;
        return $this;
    }
    /**
     * Get RequestIdValid value
     * @return bool
     */
    public function getRequestIdValid()
    {
        return $this->RequestIdValid;
    }
    /**
     * Set RequestIdValid value
     * @param bool $requestIdValid
     * @return \StructType\UserStatus
     */
    public function setRequestIdValid($requestIdValid = null)
    {
        // validation for constraint: boolean
        if (!is_null($requestIdValid) && !is_bool($requestIdValid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($requestIdValid)), __LINE__);
        }
        $this->RequestIdValid = $requestIdValid;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UserStatus
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
